<?php

class SliderController extends RController {

    /**
     * @return array action filters
     */
    public function filters() {
        return array(
            'rights',
            'postOnly + delete', // we only allow deletion via POST request
        );
    }

    /**
     * Displays a particular model.
     * @param integer $id the ID of the model to be displayed
     */
    public function actionView($id) {
        $sliderImages = SliderImages::model()->findAllByAttributes(array('slider_id' => $id));

        $this->render('view', array(
            'model' => $this->loadModel($id),
            'sliderImages' => $sliderImages,
        ));
    }

    /**
     * Creates a new model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     */
    public function actionCreate() {
        $model = new Slider;
        if (Yii::app()->options->get('I18N_MULTILINGUAL', 0) == 0) {
            $model->language = Yii::app()->language;
        }
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Slider'])) {
            $model->attributes = $_POST['Slider'];
			$model->create_datetime=strtotime('');
			$model->update_datetime=strtotime('');
            if ($model->save())
                $this->redirect(array('sliderImages/create', 'slider_id' => $model->id));
        }
        $this->render('create', array(
            'model' => $model,
        ));
    }

    /**
     * Updates a particular model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id the ID of the model to be updated
     */
    public function actionUpdate($id) {
        $model = $this->loadModel($id);
        // Uncomment the following line if AJAX validation is needed
        // $this->performAjaxValidation($model);
        if (isset($_POST['Slider'])) {
            $model->attributes = $_POST['Slider'];
			$model->update_datetime=strtotime('');
            if ($model->save()) {
                Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully updated.'));
                $this->redirect(array('admin'));
            }
        }
        $this->render('update', array(
            'model' => $model,
        ));
    }

    /**
     * Deletes a particular model.
     * If deletion is successful, the browser will be redirected to the 'admin' page.
     * @param integer $id the ID of the model to be deleted
     */
    public function actionDelete($id) {
        $model = $this->loadModel($id);
        $images = SliderImages::model()->findAllByAttributes(array('slider_id' => $id));
        if ($images) {
            foreach ($images as $image) {
                $path = Yii::app()->params['uploadDir'] . get_class($image) . '/' . $image->image;
                if (is_file($path)) {
                    unlink($path);
                }
            }
        }
        $model->delete();
        // if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
        if (!isset($_GET['ajax'])) {
            Yii::app()->user->setFlash('alert-success', Yii::t('admin', 'Item has been successfully deleted.'));
            $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
        }
    }

    /**
     * Manages all models.
     */
    public function actionAdmin() {
        $model = new Slider('search');
        $model->unsetAttributes();  // clear any default values
        if (isset($_GET['Slider']))
            $model->attributes = $_GET['Slider'];
        $this->render('admin', array(
            'model' => $model,
        ));
    }

    /**
     * Returns the data model based on the primary key given in the GET variable.
     * If the data model is not found, an HTTP exception will be raised.
     * @param integer $id the ID of the model to be loaded
     * @return Slider the loaded model
     * @throws CHttpException
     */
    public function loadModel($id) {
        $model = Slider::model()->findByPk($id);
        if ($model === null)
            throw new CHttpException(404, 'The requested page does not exist.');
        return $model;
    }

    /**
     * Performs the AJAX validation.
     * @param Slider $model the model to be validated
     */
    protected function performAjaxValidation($model) {
        if (isset($_POST['ajax']) && $_POST['ajax'] === 'slider-form') {
            echo CActiveForm::validate($model);
            Yii::app()->end();
        }
    }

    public function actionOrder($slider_id) {
        /**
         * Handle the POST request data submission
         */
        if (isset($_POST['Order'])) {
            $count = count($_POST['Order']);
            $transaction = Yii::app()->db->beginTransaction();
            try {
                $sql = "UPDATE slider_images as si SET si.order = :order WHERE si.id = :id ;";
                $cmd = Yii::app()->db->createCommand($sql);
                for ($i = 0; $i < $count; $i++) {
                    if ($id = intval($_POST['Order'][$i]))
                        $cmd->execute(array('order' => $i, 'id' => $id));
                }
            } catch (Exception $e) {
                $transaction->rollback();
                throw $e;
            }
            $transaction->commit();
            if (!Yii::app()->request->isAjaxRequest) {
                Yii::app()->user->setFlash('alert alert-success', Yii::t('admin', 'Images has been successfully reordered.'));
                $this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('slider/admin'));
            } else {
                echo '<div class="alert alert-success">' .
                Yii::t('admin', 'Images has been successfully reordered.') . '</div>';
                return;
            }
        }
    }

}
